
window.addEventListener("load", ruboardInitProc, false);

function ruboardInitProc() 
{
   window.removeEventListener("load", ruboardInitProc, false);
   window.addEventListener("unload", ruboardUninitProc, false);
   ruboardPrefObserve.register();
}

function ruboardUninitProc() 
{
   window.removeEventListener("unload", ruboardUninitProc, false); 
   ruboardPrefObserve.unregister();
}

var ruboardPrefObserve = 
{
   register: function() 
   {  
      var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);  
      this._branch = prefService.getBranch("extensions.ruboard.");  
      this._branch.QueryInterface(Components.interfaces.nsIPrefBranch2);  
      this._branch.addObserver("", this, false);
      try
      {
         this.ShowHideProc(this._branch.getBoolPref("help_menu_visible"), "ruboard_menu"); 
         this.ShowHideProc(this._branch.getBoolPref("titlebar_visible"), "ruboard_titlebar_button"); 
      }
      catch (e) { }
   },  
  
   unregister: function() 
   {  
      if (!this._branch)
      {
         return; 
      }  
      this._branch.removeObserver("", this);

   },  
  
   observe: function(aSubject, aTopic, aData) 
   {  
      if(aTopic != "nsPref:changed")
      {
         return;
      }
      switch (aData) 
      {  
         case "help_menu_visible":  
            this.ShowHideProc(this._branch.getBoolPref(aData), "ruboard_menu");
            break;  
         case "titlebar_visible":  
            this.ShowHideProc(this._branch.getBoolPref(aData), "ruboard_titlebar_button"); 
            break;  
      }        
   },
  
   ShowHideProc: function(status, item)
   {
      if (status)
      {
         document.getElementById(item).hidden = false;
      }
      else
      {
         document.getElementById(item).hidden = true;
      }
   }
}; 
