var ruboardUploadProgress = 0;

function ruboardUploadOn()
{
   var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"].getService(Components.interfaces.nsIVersionComparator);
   if (versionChecker.compare(Application.version, "4.0b4") >= 0)
   {
      document.getElementById("ruboards_ubload_box").hidden = false;
   }
   else
   {
      document.getElementById("ruboards_ubload_box").hidden = true;
   }
}
   
function ruboardGetFileProc()
{
   const nsIFilePicker = Components.interfaces.nsIFilePicker;
   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
   var nsILocalFile= Components.interfaces.nsILocalFile;
   fp.init(window, "Choose a file", nsIFilePicker.modeOpen);
   fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterImages | nsIFilePicker.filterApps);
   var rv = fp.show();
   if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) 
   {
      var path = fp.file.path;
      document.getElementById("ruboards_upload_file_path").value = path;
      ruboardEnableAllProc();
   }
}

function ruboardEnableAllProc()
{
   var FileStatus = ruboardCheckLocalFileProc(document.getElementById("ruboards_upload_file_path"), true);
   document.getElementById("ruboards_upload_rghost_progress").value = 0;
   if (FileStatus)
   {
      document.getElementById("ruboards_upload_rghost_button").disabled = false;
   }
   else
   {
      document.getElementById("ruboards_upload_rghost_button").disabled = true;
   }
}

function ruboardEnableButtonsProc(buttonID, progressID, CheckType)
{
   var FileStatus = ruboardCheckLocalFileProc(document.getElementById("ruboards_upload_file_path"), CheckType);
   document.getElementById(progressID).value = 0;
   if (FileStatus)
   {
      if (CheckType && FileStatus != 2)
      {
         document.getElementById(buttonID).disabled = true;
         return;
      }
      document.getElementById(buttonID).disabled = false;
   }
   else
   {
      document.getElementById(buttonID).disabled = true;
   }
}

function ruboardCheckLocalFileProc(FilePath, CheckType)
{
   if (FilePath.value)
   {
      FilePath.setAttribute("tooltiptext", FilePath.value);
      var CurrentFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      try
      {
         CurrentFile.initWithPath(FilePath.value);
         if (CurrentFile.exists())
         {
            if (CurrentFile.isFile())
            {
               if (CurrentFile.fileSize < 52428800)
               {
                  return 1;
               }
            }
         }
      } catch(e){}
   }
   else
   {
      FilePath.removeAttribute("tooltiptext");   
   }
   return 0;
}

function ruboardEnableFileSelection()
{
   if(ruboardUploadProgress)
   {
      document.getElementById("ruboards_upload_file_path").disabled = true;
      document.getElementById("ruboards_upload_file_button").disabled = true;
   }
   else
   {
      document.getElementById("ruboards_upload_file_path").disabled = false;
      document.getElementById("ruboards_upload_file_button").disabled = false;
   }   
}

function ruboardRghostUploadProc()
{
   var FilePath; var Request; var Progress; var ProgressMeter; var AbortButton; var UploadForm; var Html; var Body;
   
   FilePath = document.getElementById("ruboards_upload_file_path");
   if (ruboardCheckLocalFileProc(FilePath, false) == 0)
   {
      return;
   }
   document.getElementById("ruboards_upload_rghost_button").disabled = true;
   
   AbortButton = document.getElementById("ruboards_upload_rghost_abort");
   AbortButton.disabled = false;
   AbortButton.addEventListener("command", AbortRequest, false);
   ruboardUploadProgress ++;
   ruboardEnableFileSelection();
   
   Request = new XMLHttpRequest();
   Request.open("GET", "http://rghost.ru/", true);
   Request.channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
   Request.onreadystatechange = function (aEvt) 
   {  
      if (Request.readyState == 4) 
      {  
         if (Request.status == 200)
         {
            Html = document.implementation.createDocument("http://www.w3.org/1999/xhtml", "html", null);
            Body = document.createElementNS("http://www.w3.org/1999/xhtml", "body");
            Html.documentElement.appendChild(Body);
            Body.appendChild(Components.classes["@mozilla.org/feed-unescapehtml;1"].getService(Components.interfaces.nsIScriptableUnescapeHTML).parseFragment(Request.responseText, false, null, Body));

            Html.getElementById("choose").value = FilePath.value;
            UploadForm = new FormData(Html.getElementById("upload_form"));
            
            ProgressMeter = document.getElementById("ruboards_upload_rghost_progress");
            Request.upload.addEventListener("progress", Progress, false);  
            Request.open("POST", Html.getElementById("upload_form").action, true);
            Request.channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_BYPASS_CACHE;
            Request.onreadystatechange = function (aEvt) 
            {
               if (Request.readyState == 4) 
               {  
                  if (Request.status == 200)
                  {
                     ProgressMeter.value = 100;
                     Clean(false);
                     parent.gBrowser.addTab(Request.channel.URI.spec);
                  }  
                  else
                  {
                     Clean(true);   
                  }  
               }  
            };
            Request.send(UploadForm);
         }  
         else
         {
            Clean(true);   
         }  
      }  
   };  
   Request.send(null);
   Progress = function(evt) 
   {  
      var percentComplete = Math.round((evt.loaded / evt.total) * 100);  
      ProgressMeter.value = percentComplete;
   };  
   function AbortRequest()
   {
      Request.abort();
   }
   function Clean(EnableButtons)
   {
      AbortButton.removeEventListener("command", AbortRequest, false);
      if (EnableButtons)
      {
        ruboardEnableButtonsProc("ruboards_upload_rghost_button", "ruboards_upload_rghost_progress", false);
      }
      AbortButton.disabled = true;
      ruboardUploadProgress --;
      ruboardEnableFileSelection();
   }
   return;
}
